from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="TypesTasksAggregation")


@_attrs_define
class TypesTasksAggregation:
    """
    Attributes:
        assignee (str | Unset):
        doing (int | Unset):
        done (int | Unset):
        overdue (int | Unset):
        total (int | Unset):
    """

    assignee: str | Unset = UNSET
    doing: int | Unset = UNSET
    done: int | Unset = UNSET
    overdue: int | Unset = UNSET
    total: int | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        assignee = self.assignee

        doing = self.doing

        done = self.done

        overdue = self.overdue

        total = self.total

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if assignee is not UNSET:
            field_dict["assignee"] = assignee
        if doing is not UNSET:
            field_dict["doing"] = doing
        if done is not UNSET:
            field_dict["done"] = done
        if overdue is not UNSET:
            field_dict["overdue"] = overdue
        if total is not UNSET:
            field_dict["total"] = total

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        assignee = d.pop("assignee", UNSET)

        doing = d.pop("doing", UNSET)

        done = d.pop("done", UNSET)

        overdue = d.pop("overdue", UNSET)

        total = d.pop("total", UNSET)

        types_tasks_aggregation = cls(
            assignee=assignee,
            doing=doing,
            done=done,
            overdue=overdue,
            total=total,
        )

        types_tasks_aggregation.additional_properties = d
        return types_tasks_aggregation

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
